FIX: Detection if testpmd/l3fwd is up
[csit.git] / tests / dpdk / dpdk_scripts / run_l2fwd.sh
index 0e07b68..09cc112 100755 (executable)
@@ -1,38 +1,51 @@
-#!/bin/bash
+#!/usr/bin/env bash
 
-set -x
+# Copyright (c) 2020 Cisco and/or its affiliates.
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at:
+#
+#     http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
 
-# Setting variables
-DPDK_DIR=dpdk
-ROOTDIR=/tmp/openvpp-testing
-TESTPMDLOG=screenlog.0
-PWDDIR=$(pwd)
+set -xuo pipefail
 
-# Setting command line arguments
-cpu_corelist=$1
-nb_cores=$2
-queue_nums=$3
-jumbo_frames=$4
-arch=${5:-"x86_64"}
+# Setting variables.
+DPDK_DIR="dpdk"
+ROOTDIR="/tmp/openvpp-testing"
+TESTPMDLOG="screenlog.0"
+PWDDIR="$(pwd)"
 
-# dpdk prefers "arm64" to "aarch64" and does not allow arm64 native target
-if [ $arch == "aarch64" ]; then
+# Setting command line arguments.
+cpu_corelist="${1}"
+nb_cores="${2}"
+queue_nums="${3}"
+jumbo_frames="${4}"
+arch="$(uname -m)"
+
+# DPDK prefers "arm64" to "aarch64" and does not allow arm64 native target.
+if [ "${arch}" == "aarch64" ]; then
     arch="arm64"
     machine="armv8a"
 else
     machine="native"
 fi
 
-# Try to kill the testpmd
+# Try to kill the testpmd.
 sudo pgrep testpmd
-if [ $? -eq "0" ]; then
+if [ ${?} -eq "0" ]; then
     success=false
     sudo pkill testpmd
-    echo "RC = $?"
-    for attempt in {1..5}; do
+    echo "RC = ${?}"
+    for attempt in {1..30}; do
         echo "Checking if testpmd is still alive, attempt nr ${attempt}"
         sudo pgrep testpmd
-        if [ $? -eq "1" ]; then
+        if [ ${?} -eq "1" ]; then
             echo "testpmd is dead"
             success=true
             break
@@ -40,26 +53,26 @@ if [ $? -eq "0" ]; then
         echo "testpmd is still alive, waiting 1 second"
         sleep 1
     done
-    if [ "$success" = false ]; then
+    if [ "${success}" = false ]; then
         echo "The command sudo pkill testpmd failed"
         sudo pkill -9 testpmd
-        echo "RC = $?"
+        echo "RC = ${?}"
         exit 1
     fi
 else
     echo "testpmd is not running"
 fi
 
-# Try to kill the l3fwd
+# Try to kill the l3fwd.
 sudo pgrep l3fwd
-if [ $? -eq "0" ]; then
+if [ ${?} -eq "0" ]; then
     success=false
     sudo pkill l3fwd
-    echo "RC = $?"
-    for attempt in {1..5}; do
+    echo "RC = ${?}"
+    for attempt in {1..30}; do
         echo "Checking if l3fwd is still alive, attempt nr ${attempt}"
         sudo pgrep l3fwd
-        if [ $? -eq "1" ]; then
+        if [ ${?} -eq "1" ]; then
             echo "l3fwd is dead"
             success=true
             break
@@ -67,27 +80,27 @@ if [ $? -eq "0" ]; then
         echo "l3fwd is still alive, waiting 1 second"
         sleep 1
     done
-    if [ "$success" = false ]; then
+    if [ "${success}" = false ]; then
         echo "The command sudo pkill l3fwd failed"
         sudo pkill -9 l3fwd
-        echo "RC = $?"
+        echo "RC = ${?}"
         exit 1
     fi
 else
     echo "l3fwd is not running"
 fi
 
-# Remove hugepages
+# Remove hugepages.
 sudo rm -f /dev/hugepages/*
 
 sleep 2
 
-cd ${ROOTDIR}/${DPDK_DIR}/
-rm -f ${TESTPMDLOG}
-TESTPMD_BIN=./${arch}-${machine}-linuxapp-gcc/app/testpmd
+cd "${ROOTDIR}/${DPDK_DIR}/"
+rm -f "${TESTPMDLOG}"
+TESTPMD_BIN="./${arch}-${machine}-linuxapp-gcc/app/testpmd"
 
-if [ "$jumbo_frames" = "yes" ]; then
-    sudo sh -c "screen -dmSL DPDK-test $TESTPMD_BIN \
+if [ "${jumbo_frames}" = "yes" ]; then
+    sudo sh -c "screen -dmSL DPDK-test ${TESTPMD_BIN} \
         -l ${cpu_corelist} -n 4 --log-level 8 -v -- \
         --numa \
         --nb-ports=2 \
@@ -104,7 +117,7 @@ if [ "$jumbo_frames" = "yes" ]; then
         --disable-link-check \
         --auto-start"
 else
-    sudo sh -c "screen -dmSL DPDK-test $TESTPMD_BIN \
+    sudo sh -c "screen -dmSL DPDK-test ${TESTPMD_BIN} \
         -l ${cpu_corelist} -n 4 --log-level 8 -v -- \
         --numa \
         --nb-ports=2 \
@@ -120,7 +133,14 @@ else
         --auto-start"
 fi
 
-sleep 10
-less -r ${TESTPMDLOG}
+for attempt in {1..30}; do
+    echo "Checking if testpmd is alive, attempt nr ${attempt}"
+    fgrep "Port 1: link state change event" "${TESTPMDLOG}"
+    if [ "${?}" -eq "0" ]; then
+        cat "${TESTPMDLOG}"
+        exit 0
+    fi
+    sleep 1
+done
 
-cd ${PWDDIR}
+exit 1